import "Turbine"
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

local test=pcall(function() import "Deusdictum.UI.Dragbar" end)
if test==false then 

	Turbine.Shell.WriteLine("You *must* have Deusdictum's dragbar installed for Bevy to work! Get thee hence to Lotrointerface!") 
	Turbine.Shell.WriteLine("Not loading Bevy-o-bars!")
	
else

	if not pcall(function() import "JackdawPlugins.Patch.Patch" end) then 
		--Turbine.Shell.WriteLine("Patch not present - default Load and Save used")
		JackdawPlugins.Patch={}
		function JackdawPlugins.Patch.Load(a,b,c) return Turbine.PluginData.Load(a,b,c) end
		function JackdawPlugins.Patch.Save(a,b,c,d) Turbine.PluginData.Save(a,b,c,d) end
	end

	import "JackdawPlugins.Bevy2.class"
	import "JackdawPlugins.Bevy2.snapper"
	import "JackdawPlugins.Bevy2.function"
	import "JackdawPlugins.Bevy2.option"
	import "JackdawPlugins.Bevy2.OptionPanel"

	--[[
			Bevy-O-Bars version 2
			
			Concept: 	Streamline the original bevy bars with better written functions, less mandatory events.
							Make additions optional, so the player can have simple or complex a plugin as they wish.
							Written by me, for me - I will serve my needs first.
				
			To Do:

			Remove NASTY HACK! from Stance when they fix the Guardian threat table, and lord knows what else!
			Remove NASTY HACK! from Stance when they fix the WarSpeech stance for Minstrels.
			Re-enable Burglar stances when they put them in the game.
			
			]]--
			
	Load()
	Plugins["BevyOBars2"].Unload = function( sender, args )
		if Modules.popups then OpenAllPops() end --Popup module requires all popups to be open before saving. Otherwise it records the bar as being 1x1
		if Modules.Monitor then MergeList() end -- Attempt to overcome lost buffs.
		Save()

		-- Remove needed handlers.
		if classes[PlayerClass] == "Warden" then
			RemoveCallback(Turbine.Gameplay.Attributes.WardenAttributes, "StanceChanged", stanceChangedHandler);
			RemoveCallback(Turbine.Gameplay.Attributes.WardenAttributes, "GambitChanged", wardenGambitChangedHandler);
	
		elseif classes[PlayerClass] == "Burglar" then
			RemoveCallback(Turbine.Gameplay.Attributes.BurglarAttributes, "StanceChanged", stanceChangedHandler);

		elseif classes[PlayerClass] == "Champion" then
			RemoveCallback(Turbine.Gameplay.Attributes.ChampionAttributes, "StanceChanged", stanceChangedHandler);
	
		elseif classes[PlayerClass] == "Hunter" then
			RemoveCallback(Turbine.Gameplay.Attributes.HunterAttributes, "StanceChanged", stanceChangedHandler);
		
		elseif classes[PlayerClass] == "Minstrel" then
			RemoveCallback(Turbine.Gameplay.Attributes.MinstrelAttributes, "StanceChanged", stanceChangedHandler);	

		elseif classes[PlayerClass] == "Guardian" then
			RemoveCallback(Turbine.Gameplay.Attributes.GuardianAttributes, "StanceChanged", stanceChangedHandler);
	
		end
	end

end